package mvilla.posicionamientowifi.Actividades;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;

import java.util.Vector;

import mvilla.posicionamientowifi.CADODatosWifis;
import mvilla.posicionamientowifi.CDatosComunes;
import mvilla.posicionamientowifi.CMainActivity;
import mvilla.posicionamientowifi.CMgrWifi;
import mvilla.posicionamientowifi.Definiciones.CDatoDepartamento;
import mvilla.posicionamientowifi.Definiciones.CDatoMapa;
import mvilla.posicionamientowifi.Definiciones.CInfoPosicionWifi;
import mvilla.posicionamientowifi.Definiciones.CInfoWifi;
import mvilla.posicionamientowifi.R;
import mvilla.posicionamientowifi.Vistas.CVistaMapa;

/**
 * Created by Miguel on 27/10/2015.
 */
public class CAprendizaje extends Activity
{
    private CVistaMapa  m_vista;
    private Button      m_buttonGuardar;
    private Button      m_buttonVerWifis;
    private TextView    m_textNombreMapa;

    private CMgrWifi            m_mgrWifi;
    private CDatoMapa           m_datosMapa;
    private CADODatosWifis      m_conBD;;

    private int         m_posMapaEscogido = -1;

    protected void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.mapa);

        Bundle extras = getIntent().getExtras();
        if (extras != null)
        {
            m_posMapaEscogido = extras.getInt(CDatosComunes.POSICION_MAPA_ESCOGIDO);
        }

        if (m_posMapaEscogido == -1)
            finish();

        m_datosMapa = CMainActivity.m_vMapas.elementAt(m_posMapaEscogido);

        m_mgrWifi = new CMgrWifi(getBaseContext());
        m_mgrWifi.IniciarlizarMgr();
        m_conBD = new CADODatosWifis(getBaseContext());

        m_vista = (CVistaMapa) findViewById(R.id.view);

        m_vista.SetDatosMapa(m_datosMapa, true);
        m_buttonGuardar = (Button)findViewById(R.id.cmdGuardar);
        m_buttonGuardar.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
                onClickGuardar();
            }
        });

        m_buttonVerWifis = (Button)findViewById(R.id.cmdVerWifis);
        m_buttonVerWifis.setOnClickListener(new View.OnClickListener()
        {
            public void onClick(View view)
            {
                OnClickVerWifis();
            }
        });

        m_textNombreMapa = (TextView)findViewById(R.id.nombreMapa);
        m_textNombreMapa.setText(m_datosMapa.Nombre());
    }

    private void onClickGuardar ()
    {
        //Pedimos el dato al mapa
        CInfoPosicionWifi datoDep = m_vista.GetPosicionSeleccionada();

        if (datoDep == null)
        {
            //Mensaje de error
            return;
        }

        //Pedimos los datos de la wifi
        datoDep.m_vValoresWifi = m_mgrWifi.EscanearWifis();


         m_conBD.SaveDatosWifis(m_datosMapa.Nombre(), datoDep);

         Toast.makeText(this, "Guardado datos para " + datoDep.m_nombreDepartamento, Toast.LENGTH_SHORT).show();
    }

    private void OnClickVerWifis ()
    {
        Intent i = new Intent (this, CListaWifis.class);
        startActivity(i);
    }

    protected void onPause ()
    {
        super.onPause();
    }

    protected void onResume ()
    {
        super.onResume();
    }

    protected  void onDestroy ()
    {
        super.onDestroy();
    }
}
