package mvilla.posicionamientowifi.Actividades;

import android.app.ListActivity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.ListView;

import java.util.Vector;

import mvilla.posicionamientowifi.Adaptadores.CAdaptadorListaWifis;
import mvilla.posicionamientowifi.CDatosComunes;
import mvilla.posicionamientowifi.CMainActivity;
import mvilla.posicionamientowifi.CMgrWifi;
import mvilla.posicionamientowifi.Definiciones.CDatoMapa;
import mvilla.posicionamientowifi.Definiciones.CInfoWifi;
import mvilla.posicionamientowifi.R;

/**
 * Created by Miguel on 30/10/2015.
 */
public class CListaWifis  extends ListActivity
{

    private CAdaptadorListaWifis m_adaptador;

    private CMgrWifi m_mgrWifi;

    private Vector<CInfoWifi> m_vDatosWifis;

    private Button m_cmdRefrescar;

    private ListView m_listView;


    protected void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.lista_wifis);
        m_mgrWifi = new CMgrWifi(getBaseContext());
        m_mgrWifi.IniciarlizarMgr();
        m_vDatosWifis = m_mgrWifi.EscanearWifis(100);

        m_adaptador = new CAdaptadorListaWifis(this, m_vDatosWifis);
        setListAdapter(m_adaptador);

        m_cmdRefrescar = (Button)findViewById(R.id.cmdRefrescar);
        m_cmdRefrescar.setOnClickListener(new View.OnClickListener()
        {
            public void onClick(View view)
            {
                OnButtonRefrescar();
            }
        });
    }

    @Override
    public void onListItemClick(ListView lista, View view, int i, long l)
    {
        super.onListItemClick(lista, view, i, l);

        //i es la posicion que se ha pulsado
        Intent intent = new Intent();
        intent.putExtra(CDatosComunes.POSICION_MAPA_ESCOGIDO, i);
        setResult(RESULT_OK, intent);
        finish();
    }

    private void OnButtonRefrescar ()
    {
        try
        {
            m_cmdRefrescar.setEnabled(false);

            m_vDatosWifis = m_mgrWifi.EscanearWifis(100);
            for (int i = 0; i < m_vDatosWifis.size(); i++) {
                ((CInfoWifi) m_adaptador.getItem(i)).m_nombre = m_vDatosWifis.elementAt(i).m_nombre;
                ((CInfoWifi) m_adaptador.getItem(i)).m_potencia = m_vDatosWifis.elementAt(i).m_potencia;
            }

            m_adaptador.notifyDataSetChanged();

            m_cmdRefrescar.setEnabled(true);
        }
        catch (Exception e)
        {
            m_cmdRefrescar.setEnabled(true);
        }
    }
}
