package mvilla.posicionamientowifi.Actividades;

import android.app.Activity;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;

import java.util.Vector;

import mvilla.posicionamientowifi.CADODatosWifis;
import mvilla.posicionamientowifi.CDatosComunes;
import mvilla.posicionamientowifi.CMainActivity;
import mvilla.posicionamientowifi.CMgrWifi;
import mvilla.posicionamientowifi.CMgrWifiRunnable;
import mvilla.posicionamientowifi.Definiciones.CDatoMapa;
import mvilla.posicionamientowifi.Definiciones.CInfoPosicionWifi;
import mvilla.posicionamientowifi.Definiciones.CInfoWifi;
import mvilla.posicionamientowifi.R;
import mvilla.posicionamientowifi.Vistas.CVistaMapa;

public class CPosicionamiento extends Activity
{
    public static  Vector<CInfoPosicionWifi> m_vDatosWifiMapaEscogido;

    private CMgrWifiRunnable m_mgrWifi;
    private CDatoMapa m_datosMapa;
    private int         m_posMapaEscogido = -1;
    private CVistaMapa  m_vista;
    private TextView    m_textNombreMapa;

    Button              m_cmdEmpezarPos;

    boolean             m_estamosLeyendoPosicion = false;

    boolean             m_estamosEscaneando = false;

    @Override
    protected void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);

        setContentView(R.layout.mapa_posicionamiento);

        Bundle extras = getIntent().getExtras();
        if (extras != null)
        {
            m_posMapaEscogido = extras.getInt(CDatosComunes.POSICION_MAPA_ESCOGIDO);
        }

        if (m_posMapaEscogido == -1)
            finish();

        m_vista = (CVistaMapa) findViewById(R.id.view);

        m_datosMapa = CMainActivity.m_vMapas.elementAt(m_posMapaEscogido);

        m_mgrWifi = new CMgrWifiRunnable(getBaseContext(), m_vista);
        m_mgrWifi.IniciarlizarMgr();



        m_vista.SetDatosMapa(m_datosMapa, false);

        m_textNombreMapa = (TextView)findViewById(R.id.nombreMapaPosicionamiento);
        m_textNombreMapa.setText(m_datosMapa.Nombre());

        m_cmdEmpezarPos = (Button) findViewById(R.id.cmdEmpezarPosicionamiento);
        m_cmdEmpezarPos.setText("Empezar");
        m_cmdEmpezarPos.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
                OnClickEmpezar();
            }
        });

        LeerDatosMapaEscogido();
    }

    private void OnClickEmpezar()
    {
        if (!m_estamosEscaneando)
        {
            m_estamosEscaneando = true;
            m_mgrWifi.start();
            m_cmdEmpezarPos.setText("Pausar");
        }
        else
        {
            m_estamosEscaneando = false;
            m_cmdEmpezarPos.setText("Empezar");
            m_mgrWifi.stop();
        }
    }


    private void LeerDatosMapaEscogido ()
    {
        CADODatosWifis adoWifis  = new CADODatosWifis(this);
       m_vDatosWifiMapaEscogido  = adoWifis.GetDatosWifis(m_datosMapa.Nombre());
    }

    protected void onDestroy()
    {
        m_mgrWifi.PararHilo();
        super.onDestroy();
    }
}
