package mvilla.posicionamientowifi;

import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;

import java.util.Vector;

import mvilla.posicionamientowifi.Definiciones.CInfoPosicionWifi;
import mvilla.posicionamientowifi.Definiciones.CInfoWifi;

/**
 * Created by Miguel on 26/10/2015.
 */
public class CADODatosWifis extends SQLiteOpenHelper
{

    public CADODatosWifis (Context context)
    {
        super (context, "BDDatosWifis", null, 1);
    }

    @Override
    public void onCreate(SQLiteDatabase db)
    {
        String sql = "";
        sql = "CREATE TABLE DATOS_WIFI ";
        sql += "( ";
        sql += "NOMBRE_LUGAR TEXT, ";
        sql += "POS_X REAL, ";
        sql += "POS_Y REAL, ";
        sql += "MAC_WIFI TEXT, ";
        sql += "POTENCIA_WIFI INTEGER, ";
        sql += "PRIMARY KEY (NOMBRE_LUGAR, POS_X, POS_Y, MAC_WIFI)";
        sql += ");";

        db.execSQL(sql);
    }

    @Override
    public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion)
    {

    }

    public Vector<CInfoPosicionWifi> GetDatosWifis (String lugar)
    {
        Vector<CInfoPosicionWifi> vRet = new Vector<CInfoPosicionWifi>();

        String sql = "SELECT POS_X, POS_Y, MAC_WIFI, POTENCIA_WIFI FROM DATOS_WIFI WHERE NOMBRE_LUGAR = '" + lugar + "' ORDER BY POS_X, POS_Y, MAC_WIFI";

        SQLiteDatabase db = getReadableDatabase();
        Cursor cur = db.rawQuery(sql, null);

        int posXAnt = -1;
        int posYAnt = -1;
        while (cur.moveToNext())
        {
            int posX = cur.getInt(0);
            int posY = cur.getInt(1);

            if (posXAnt != posX || posYAnt != posY)
            {
                CInfoPosicionWifi dato = new CInfoPosicionWifi();
                dato.m_posX = posX;
                dato.m_posY = posY;

                vRet.add(dato);

                posXAnt = posX;
                posYAnt = posY;
            }

            CInfoWifi datoWifi = new CInfoWifi();
            datoWifi.m_nombre = cur.getString(2);
            datoWifi.m_mac = cur.getString(2);
            datoWifi.m_potencia = cur.getInt(3);

            vRet.lastElement().m_vValoresWifi.add(datoWifi);
        }

        return vRet;
    }

    public boolean SaveDatosWifis (String nombreMapa, CInfoPosicionWifi datos)
    {
        try
        {
            SQLiteDatabase db = getWritableDatabase();

            //Borramos los posibles datos anterioes de este punto
            String sql = "DELETE FROM DATOS_WIFI WHERE NOMBRE_LUGAR = '" + nombreMapa + "' AND POS_X = " + datos.m_posX +  " AND POS_Y = " + datos.m_posY;
            db.execSQL(sql);

            for (int j = 0; j < datos.m_vValoresWifi.size(); j++) {
                sql = "INSERT INTO DATOS_WIFI VALUES ('" + nombreMapa + "', " + datos.m_posX + ", " + datos.m_posY + ", '" + datos.m_vValoresWifi.elementAt(j).m_mac + "', ";
                sql += datos.m_vValoresWifi.elementAt(j).m_potencia + ")";

                db.execSQL(sql);
            }

            return true;
        }
        catch (Exception e)
        {
            return false;
        }
    }

    public boolean ClearDatosMapa (String nombreMapa)
    {
        try
        {
            SQLiteDatabase db = getWritableDatabase();

            //Borramos los posibles datos anterioes de este punto
            String sql = "DELETE FROM DATOS_WIFI WHERE NOMBRE_LUGAR = '" + nombreMapa + "'";
            db.execSQL(sql);

            return true;
        }
        catch (Exception e)
        {
            return false;
        }
    }
}
