package mvilla.posicionamientowifi;

import android.content.Context;
import android.content.Intent;
import android.net.wifi.ScanResult;
import android.net.wifi.WifiManager;

import java.util.List;
import java.util.Vector;

import mvilla.posicionamientowifi.Actividades.CPosicionamiento;
import mvilla.posicionamientowifi.Definiciones.CInfoPosicionWifi;
import mvilla.posicionamientowifi.Definiciones.CInfoWifi;
import mvilla.posicionamientowifi.Vistas.CVistaMapa;

/**
 * Created by Miguel on 28/10/2015.
 */
public class CMgrWifiRunnable extends Thread
{
    WifiManager m_wifiMgr;
    Context m_context;
    boolean m_pararHilo = false;
    CVistaMapa m_mapa;

    boolean     m_estamosPosicionando = false;

    public CMgrWifiRunnable (Context c, CVistaMapa mapa)
    {
        m_context = c;
        m_mapa = mapa;
    }

    public void PararHilo ()
    {
        m_pararHilo = true;
    }

    public  boolean IniciarlizarMgr ()
    {
        try
        {
            m_wifiMgr = (WifiManager)m_context.getSystemService(Context.WIFI_SERVICE);

            return true;
        }
        catch (Exception e)
        {
            return false;
        }
    }

    public Vector<CInfoWifi> EscanearWifis ()
    {
        return EscanearWifis(CDatosComunes.FACTOR_DIVISION_WIFI);
    }

    private Vector<CInfoWifi> EscanearWifis (int divisor)
    {
        m_wifiMgr.startScan();

        List<ScanResult> wifiScanList = m_wifiMgr.getScanResults();

        Vector<CInfoWifi> vRet = new Vector<CInfoWifi>();

        for(int i = 0; i < wifiScanList.size(); i++)
        {
            CInfoWifi dato = new CInfoWifi();
            dato.m_nombre = wifiScanList.get(i).SSID;
            dato.m_mac = wifiScanList.get(i).BSSID;
            dato.m_potencia = wifiScanList.get(i).level;

            dato.m_potencia = WifiManager.calculateSignalLevel(wifiScanList.get(i).level, divisor);

            vRet.add(dato);
        }

        return vRet;
    }


    @Override
    public void run()
    {
        while (!m_pararHilo)
        {
            Vector<CInfoWifi> vRet = EscanearWifis();

            SetPosicionLeida(vRet);

            try
            {
                Thread.sleep(5000);
            }
            catch (InterruptedException e)
            {

            }
        }
    }

    public void SetPosicionLeida (Vector<CInfoWifi> vDatosWifisLeido)
    {
        try
        {
            if (m_estamosPosicionando)
                return;

            long potenciaMax = Long.MAX_VALUE;
            int posPuntoEscogido = -1;

            //Buscamos en el vector guardado para ver cuanta diferencia hay entre entre punto leído y los que tenemos guardados
            for (int nPuntoGuardado = 0; nPuntoGuardado < CPosicionamiento.m_vDatosWifiMapaEscogido.size(); nPuntoGuardado++)
            {
                CInfoPosicionWifi infoWifiGuardada = CPosicionamiento.m_vDatosWifiMapaEscogido.elementAt(nPuntoGuardado);
                long diffPotencia = 0;
                for (int nWifiGuardada = 0; nWifiGuardada < infoWifiGuardada.m_vValoresWifi.size(); nWifiGuardada++)
                {
                    for (int nWifi = 0; nWifi < vDatosWifisLeido.size(); nWifi++)
                    {
                        String macWifi = vDatosWifisLeido.elementAt(nWifi).m_mac;
                        int potencia = vDatosWifisLeido.elementAt(nWifi).m_potencia;

                        if (infoWifiGuardada.m_vValoresWifi.elementAt(nWifiGuardada).m_mac.equals(macWifi))
                        {
                            diffPotencia += Math.pow((potencia - infoWifiGuardada.m_vValoresWifi.elementAt(nWifiGuardada).m_potencia), 2);
                        }
                    }
                }

                if (diffPotencia < potenciaMax)
                {
                    potenciaMax = diffPotencia;
                    posPuntoEscogido = nPuntoGuardado;
                }
            }

            if (posPuntoEscogido != -1)
            {
                m_mapa.SetPosicion(CPosicionamiento.m_vDatosWifiMapaEscogido.elementAt(posPuntoEscogido).m_posX, CPosicionamiento.m_vDatosWifiMapaEscogido.elementAt(posPuntoEscogido).m_posY);
                m_mapa.postInvalidate();
            }

            m_estamosPosicionando = false;
        }
        catch (Exception e)
        {
            m_estamosPosicionando = false;
        }
    }
}