package mvilla.posicionamientowifi.Definiciones;

import android.graphics.Color;

import java.util.HashMap;
import java.util.Locale;

/**
 * Created by Miguel on 27/10/2015.
 */

//Colores permitidos:  'red', 'blue', 'green', 'black', 'white', 'gray', 'cyan', 'magenta', 'yellow', 'lightgray', 'darkgray', 'grey', 'lightgrey', 'darkgrey', 'aqua', 'fuchsia', 'lime', 'maroon', 'navy', 'olive', 'purple', 'silver', 'teal'.
public class CDatoDepartamento implements  IDatoDepartamento{
    int  m_posX;
    int m_posY;
    int m_alto;
    int m_ancho;
    int  m_color;
    String m_nombre;

    private static final HashMap<String, Integer> sColorNameMap;

    static {
        sColorNameMap = new HashMap<String, Integer>();
        sColorNameMap.put("black", Color.BLACK);
        sColorNameMap.put("darkgray", Color.DKGRAY);
        sColorNameMap.put("gray", Color.GRAY);
        sColorNameMap.put("lightgray", Color.LTGRAY);
        sColorNameMap.put("white", Color.WHITE);
        sColorNameMap.put("red", Color.RED);
        sColorNameMap.put("green", Color.GREEN);
        sColorNameMap.put("blue", Color.BLUE);
        sColorNameMap.put("yellow", Color.YELLOW);
        sColorNameMap.put("cyan", Color.CYAN);
        sColorNameMap.put("magenta", Color.MAGENTA);
        sColorNameMap.put("aqua", 0xFF00FFFF);
        sColorNameMap.put("fuchsia", 0xFFFF00FF);
        sColorNameMap.put("darkgrey", Color.DKGRAY);
        sColorNameMap.put("grey", Color.GRAY);
        sColorNameMap.put("lightgrey", Color.LTGRAY);
        sColorNameMap.put("lime", 0xFF00FF00);
        sColorNameMap.put("maroon", 0xFF800000);
        sColorNameMap.put("navy", 0xFF000080);
        sColorNameMap.put("olive", 0xFF808000);
        sColorNameMap.put("purple", 0xFF800080);
        sColorNameMap.put("silver", 0xFFC0C0C0);
        sColorNameMap.put("teal", 0xFF008080);

    }

    public CDatoDepartamento() {
        m_posX = -1;
        m_posY = -1;
        m_alto = -1;
        m_ancho = -1;
        m_color = Color.BLACK;
        m_nombre = "";
    }

    public CDatoDepartamento(int posX, int posY, int alto, int ancho, String color, String nombre) {
        m_posX = posX;
        m_posY = posY;
        m_alto = alto;
        m_ancho = ancho;
        m_color = sColorNameMap.get(color.toLowerCase(Locale.ROOT));
        m_nombre = nombre;
    }

    public CDatoDepartamento(CDatoDepartamento dato) {
        m_posX = dato.PosX();
        m_posY = dato.PosY();
        m_alto = dato.Alto();
        m_ancho = dato.Ancho();
        m_color = dato.Color();
        m_nombre = dato.Nombre();
    }


    public void PosX(int posX) {
        m_posX = posX;
    }

    public void PosY(int PosY) {
        m_posY = PosY;
    }

    public void Alto (int alto)
    {
        m_alto = alto;
    }

    public void Ancho (int ancho)
    {
        m_ancho = ancho;
    }

    public void Color (String color)
    {
        m_color = Color.parseColor(color);
    }

    public void Nombre (String nombre)
    {
        m_nombre = nombre;
    }


    public int PosX ()
    {
        return m_posX;
    }

    public int PosY ()
    {
        return m_posY;
    }

    public int Ancho ()
    {
        return m_ancho;
    }

    public int Alto ()
    {
        return m_alto;
    }

    public String Nombre ()
    {
        return m_nombre;
    }

    public int Color ()
    {
        return m_color;
    }
}


