package mvilla.posicionamientowifi.Vistas;

import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Path;
import android.graphics.drawable.Drawable;
import android.graphics.drawable.ShapeDrawable;
import android.graphics.drawable.shapes.PathShape;
import android.view.View;

import mvilla.posicionamientowifi.Definiciones.CDatoDepartamento;
import mvilla.posicionamientowifi.Definiciones.IDatoDepartamento;

/**
 * Created by Miguel on 27/10/2015.
 */
public class CVistaDepartamento extends CDatoDepartamento implements IDatoDepartamento
{
    private View m_view;

    private boolean m_bSeleccionado;

    public CVistaDepartamento (View view, CDatoDepartamento dato)
    {
        super (dato);
        m_view = view;
        m_bSeleccionado = false;
    }

    public void Seleccionado (boolean sel)
    {
        m_bSeleccionado = sel;
    }

    public boolean Seleccionado ()
    {
        return (m_bSeleccionado);
    }

    public void DibujarDepartamento (Canvas canvas)
    {
        Paint p = new Paint();
        p.setStrokeWidth(3);
        p.setColor(Color());

        canvas.save();
        if (!m_bSeleccionado)
        {
            canvas.drawLine(PosX(), PosY(), PosX() + Ancho(),
                    PosY(), p);

            canvas.drawLine(PosX(), PosY(), PosX(),
                    PosY() + Alto(), p);

            canvas.drawLine(PosX() + Ancho(), PosY() + Alto(), PosX(),
                    PosY() + Alto(), p);

            canvas.drawLine(PosX() + Ancho(), PosY(), PosX() + Ancho(),
                    PosY() + Alto(), p);
        }
        else
        {
            canvas.drawRect(PosX(), PosY(), PosX() + Ancho(),
                    PosY() + Alto(), p);
        }
        canvas.restore();

        //Invalidamos la parte que ocupa el gráfico
        m_view.postInvalidate (PosX(), PosY(), PosX() + Ancho(),
                PosY() + Alto());

    }

    public void Invalidate() {
        //Invalidamos la parte que ocupa el gráfico
        m_view.postInvalidate(PosX(), PosY(), PosX() + Ancho(),
                PosY() + Alto());
    }


    public boolean PertenceADepartamento (float x, float y)
    {
        if (x >= PosX()  && x <= PosX() + Ancho() && y >= PosY() && y <= PosY() + Alto())
            return true;

        return false;
    }
}

