package mvilla.posicionamientowifi.XMLParser;

import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

import java.util.Vector;
import java.util.jar.Attributes;

import mvilla.posicionamientowifi.Definiciones.CDatoDepartamento;
import mvilla.posicionamientowifi.Definiciones.CDatoMapa;

/**
 * Created by Miguel on 28/10/2015.
 */
public class CManejadorXML extends DefaultHandler
{
    private StringBuilder       m_cadena;
    private CDatoMapa           m_datosMapa;
    private CDatoDepartamento   m_datoDepartamento;
    private Vector<CDatoMapa>   m_vDatosMapas;

    public Vector<CDatoMapa> GetDatosLeidos ()
    {
        return m_vDatosMapas;
    }

    public void startDocument () throws SAXException
    {
        m_vDatosMapas = new Vector<CDatoMapa>();
        m_cadena = new StringBuilder();
    }

    public void startElement (String uri, String nombreLocal,
                              String nombreCualif, org.xml.sax.Attributes attributes)
    {
        m_cadena.setLength(0);

        if (nombreLocal.equals("Mapa"))
        {
            m_datosMapa = new CDatoMapa ("");
            m_datosMapa.Nombre(attributes.getValue("nombre"));
        }
        else if (nombreLocal.equals("Departamento"))
        {
            m_datoDepartamento = new CDatoDepartamento();
            m_datoDepartamento.Nombre(attributes.getValue("nombre"));
        }
    }

    public void characters (char ch[], int start, int length)
            throws SAXException
    {
        m_cadena.append(ch, start, length);
    }

    public void endElement (String uri, String nombreLocal, String nombreCualif)
            throws SAXException
    {
        if (nombreLocal.equals("PosX"))
        {
            m_datoDepartamento.PosX(Integer.parseInt(m_cadena.toString()));
        }
        else if (nombreLocal.equals("PosY"))
        {
            m_datoDepartamento.PosY(Integer.parseInt(m_cadena.toString()));
        }
        else if (nombreLocal.equals("Alto"))
        {
            m_datoDepartamento.Alto(Integer.parseInt(m_cadena.toString()));
        }
        else if (nombreLocal.equals("Ancho"))
        {
            m_datoDepartamento.Ancho(Integer.parseInt(m_cadena.toString()));
        }
        else if (nombreLocal.equals("Color"))
        {
            m_datoDepartamento.Color(m_cadena.toString());
        }
        else if (nombreLocal.equals("Departamento"))
        {
            m_datosMapa.GetDatosDepartamentos().add(m_datoDepartamento);
        }
        else if (nombreLocal.equals("Mapa"))
        {
            m_vDatosMapas.add(m_datosMapa);
        }
    }

    public void endDocument () throws  SAXException
    {
    }
}
