package mvilla.posicionamientowifi.XMLParser;

import android.content.Context;
import android.os.Environment;

import org.xml.sax.InputSource;
import org.xml.sax.XMLReader;

import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.util.Vector;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import mvilla.posicionamientowifi.Definiciones.CDatoDepartamento;
import mvilla.posicionamientowifi.Definiciones.CDatoMapa;

/**
 * Created by Miguel on 28/10/2015.
 */
public class CMgrXML
{
    private static String NOMBRE_FICHERO = "MapasPosicionamiento.xml";

    private Context             m_contexto;
    private Vector<CDatoMapa>   m_vDatosMapa;
    private boolean             m_bListaCargada;

    public CMgrXML (Context context)
    {
        m_contexto = context;
        m_vDatosMapa = new Vector<CDatoMapa>();
        m_bListaCargada = false;
    }

    public Vector<CDatoMapa> GetDatosMapas ()
    {
        try
        {
            if (!m_bListaCargada)
            {
                String kk = m_contexto.getExternalFilesDir("xml") + File.separator + "PosicionamientoWifi" + File.separator + NOMBRE_FICHERO;
                File fichero  = new File (m_contexto.getExternalFilesDir("xml") + File.separator + "PosicionamientoWifi" + File.separator + NOMBRE_FICHERO);

                InputStream streamEntrada = new FileInputStream(fichero);
                SAXParserFactory fabrica = SAXParserFactory.newInstance();
                SAXParser parser = fabrica.newSAXParser();
                XMLReader lector = parser.getXMLReader();
                CManejadorXML manejadorXML = new CManejadorXML();
                lector.setContentHandler(manejadorXML);
                lector.parse(new InputSource(streamEntrada));

                m_vDatosMapa = manejadorXML.GetDatosLeidos();

                m_bListaCargada = true;
            }

            return m_vDatosMapa;
        }
        catch (Exception e)
        {
            m_vDatosMapa.clear();
            return m_vDatosMapa;
        }
    }

}
